<?php
/*
   Run this first with an older PHP interpreter, and then with a newer
   version. This way you get a list (once) of added functions (the func
   list is stored in a temporary file).
*/

#-- load last list
if ($f = @fopen("ckavail.last", "r")) {
   $oldl = unserialize(fread($f, 1<<20));
   fclose($f);
}

#-- current func list
$curl = get_defined_functions();
$curl = $curl["internal"];

#-- save this one
if ($f = fopen("ckavail.last", "w")) {
   fwrite($f, serialize($curl));
   fclose($f);
}

#-- comparison of  current / last run
echo "old(".count($oldl)."), new(".count($curl).")\n";
if ($oldl) {
   $new = array_diff($curl, $oldl);
   echo "New functions added in PHP ". PHP_VERSION ." interpreter:\n";
   print_r($new);
}
else {
   echo "Now start this script a 2nd time with the newer interpreter version.\n";
}


?>