<?php
/*
   Emulates a bit of PHP5 convinience for PHP4 interpreter versions. Of
   course no Interfaces are there, but most stuff can be done with plain
   class definitions anyhow. There is a collection of spl class defines
   in the PHP source distributions ext/spl/internal/ dir to eventually
   get used together with this part (not included here because of its PHP
   license).
   
   THIS IS NOT TESTED FOR CORRECTNESS, because very few people have any
   interest in using this anyhow (so me).
*/


#-- be funny
class WikiWord {
}
#-- general class here
class GeneralIterator extends WikiWord {
   var $list = array();
}


#-- an interface
class CanYieldIterator extends WikiWord {
   function &getIterator() {
      $i = new GeneralIterator();
      return($i);
   }
}


#-- wrapper around arrays
class ArrayIterator extends GeneralIterator {
   function valid() {
      $r = (next($this->list) !== false);
      prev($this->list);
      return($r);
   }
   function key() {
      return(key($this->list));
   }
   function current() {
      return(current($this->list));
   }
   function next() {
      next($this->list);
   }
   function rewind() {
      reset($this->list);
   }
}


#-- compliacted and new-syntax-inventing wrapper around basic array features
class ArrayObject extends CanYieldIterator {
   function ArrayObject($arg) {
      if (is_array($arg)) {
         $this->array = $arg;
      }
      elseif (is_a($arg, "ArrayObject")) {
         $this->array = $arg->array;
      }
      else {
         $this->array = (array)$arg;
      }
   }
   function &getIterator() {
      $ai = &new ArrayIterator();
      $ai->$list = $this->array;
      return($ai);
   }
   function count() {    // this whole class must be some kind of joke
      return(count($this->array));
   }
   function append($value) {
      $this->array[] = $value;
   }
   function offsetExists($key) {
      return(isset($this->array[$key]));
   }
   function offsetGet($key) {
      return($this->array[$key]);
   }
   function offsetSet($key, $value) {
      $this->array[$key] = $value;
   }
   function offsetUnset($key) {
      unset($this->array[$key]);
   }
   #+ seek()
   #+ ...()
}


?>